function [s,kend,ktrace] = AOgen(trn,sfx,n,p,k)
% [s, kend, ktrace] = UFOgen(trn,sfx,n,p,k)
% Generate new sequence using a Audio Oracle
% input:
% trn - transition cell structure
% sfx - suffix vector
% n - length of the string to be generated
% p - probability of change (replication vs. recombination)
% k - starting point
% output:
% s - new sequence
% kend - end point (index of the original sequence)

if nargin == 3,
    p = 0.5; %0.9
    k = 1; %k = ceil(rand*length(sfx)); %1;
elseif nargin == 4 | (nargin == 5 & isempty(k)),
    k = ceil(rand*length(sfx)); %1;
end

ktrace = 1;

%k = 1;
for i = 1:n,
    if sfx(k) ~= 0,
        if (rand < p), %1/16/05 Shlomo: changed from (k <= size(trn,1))
            %copy forward according to trn
            I = trn{k};
            sym = I(ceil(rand*length(I)));
            s(i) = sym-1;
            k = sym;
            ktrace = [ktrace k];
%             if k < size(trn,1),%copy forward next only
%                 s(i) = k; %copy next symbol
%                 k = k+1;
%                 ktrace = [ktrace k];                
%             else
%                 %copy forward according to trn
%                 I = trn{k};
%                 sym = I(ceil(rand*length(I)));
%                 s(i) = sym-1;
%                 k = sym;
%                 ktrace = [ktrace k];                
%             end
        else
            k = sfx(k); %go back and copy any of the next symbols
            ktrace = [ktrace k];
            I = trn{k};
            sym = I(ceil(rand*length(I))); %choose one of the continuation states
            s(i) = sym-1;
            k = sym;
            ktrace = [ktrace k];
        end
    else
        if k < length(trn),
            s(i) = find(trn{k}==k+1); %copy forward next only (even if rand > p) 
            k = k+1;
            ktrace = [ktrace k];
        else
            nextk = rand*length(trn);
            s(i) = find(trn{1} == nextk);
            k = nextk;
            ktrace = [ktrace k];
        end
    end
end

kend = k;