%THIS SCRIPT SHOWs HOW TO RUN AO AND COMPUTE IR FOR A GIVEN THRESHOLD
%TO SEARCH OVER THRESHOLDS SEE DoAOIRThresh.m

if 0,
%Read Sound File
disp('Read mp3 ...')
[x,fs] = mp3read('/Users/sdubnov/Music/Granot/MN_COMP_no_silence-219rep.mp3',[],1,4);
%[x,fs] = mp3read('/Users/sdubnov/Music/Granot/LM_COMP_no_silence-157rep.mp3',[],1,4);
%[x,fs] = mp3read('/Users/sdubnov/Music/Classical/BEETHOVEN_SonF-1_Knorre.mp3',[],1,4);
%[x,fs] = mp3read('/Users/sdubnov/Music/Classical/BEETHOVEN_PianoSonataNo23_1_Steen-Nokleberg.mp3',[],1,4);
%[x,fs] = mp3read('/Users/sdubnov/Music/iTunes/iTunes Music/Elvis Presley/Unknown Album/Yesterday.mp3',[],1,4);
end

if 0,
%Features to be extracted
disp('.. Feature extraction')
bufsize = 2200; %200 msec * 11025 sample/sec = 220.5
%bufsize = 6616; %8192; %2048; %1024; %4096; %600 msec * 11025 sample/sec = 6615.5
hopsize = bufsize/2;
CCfrom = 2;
CCto = 30; %30; %80; %16 %80; %50; %30;
xmat = buffer(x,bufsize,hopsize);
cepsmat = rceps(xmat); %sometimes rceps is -Inf. Should be corrected.
xceps = cepsmat(CCfrom:CCto,:);
end

%AO to be created
thresh = 0.013 %0.003; %0.011; %0.015%0.005
disp('AO to be created ...')
s = sprintf('Parameters are CC=[%d %d], Threshold=%4.3f\n',...
    CCfrom,CCto,thresh);
disp(s)
[trn,sfx,lrs,si,sj] = AOS(xceps,thresh); %for testing sparse representation si,sj

%Create Compror Representation
[code,compror]=encode(sfx,lrs); 
    
%Calculate Information Rate from Compror
IR = [];
C0 = log2(length(cell2mat(trn(1))));
N = length(lrs); %equal to length of the original sequence
M = max(lrs);
C1 = log2(N)+log2(M);
for i = 2:length(compror),
    L = compror(i)-compror(i-1);
    IR(compror(i-1):compror(i)) = max(C0 - C1/L,0);
end


TotalIR = sum(IR)/length(trn)
%smoothing might be desirable
%IR = conv(IR,[0.25 0.5 1 0.5 0.25]/2.5);

%Display results
figure
tt = [1:length(IR)]*bufsize/2/fs;
plot(tt,IR,'k')
axis([0 tt(end) 0 max(IR)+1])
TX = xlabel('time (sec.)')
set(TX, 'Fontsize', 12)
TY = ylabel('IR (bits/frame)')
set(TY, 'Fontsize', 12)
TTL = sprintf('IR analysis derived from AO with threshold %0.6g', thresh);
TH = title(TTL)
set(TH, 'Fontsize', 16)
%print('-deps','-r200','AOIR-Fig1.eps')
