%This script shows how to run a search over possible threshold values
%Each parameter value creates a new AO
%Similar search can be done over feature space, such as
%CCfrom = 2;
%CCto = 30; %30; %80; %16 %80; %50; %30;
%CClist = [10:10:80];
%for CCto = CClist %... 
%threshlist = [0.0005:0.001:0.015];
threshlist = [0.005:0.002:0.020];

if 0,
%Read Sound File
disp('Read mp3 ...')
%[x,fs] = mp3read('/Users/sdubnov/Music/Granot/MN_COMP_no_silence-219rep.mp3',[],1,4);
[x,fs] = mp3read('/Users/sdubnov/Music/Granot/LM_COMP_no_silence-157rep.mp3',[],1,4);
%[x,fs] = mp3read('/Users/sdubnov/Music/Granot/GH_COMP_no_silence-141rep.mp3',[],1,4);
%-----
%[x,fs] = mp3read('/Users/sdubnov/Music/Classical/BEETHOVEN_SonF-1_Knorre.mp3',[],1,4);
%[x,fs] = mp3read('/Users/sdubnov/Music/Classical/BEETHOVEN_PianoSonataNo23_1_Steen-Nokleberg.mp3',[],1,4);
%[x,fs] = mp3read('/Users/sdubnov/Music/iTunes/iTunes Music/Elvis Presley/Unknown Album/Yesterday.mp3',[],1,4);

%Features to be extracted
disp('.. Feature extraction')
%bufsize = 4096; %370 msec * 11025 sample/sec = 220.5
%bufsize = 2200; %200 msec * 11025 sample/sec = 220.5
bufsize = 6616; %8192; %2048; %1024; %4096; %60 msec * 11025 sample/sec = 6615.5
hopsize = bufsize/2;
CCfrom = 2;
CCto = 30; %30; %80; %16 %80; %50; %30;
xmat = buffer(x,bufsize,hopsize);
cepsmat = rceps(xmat); %sometimes rceps is -Inf. Should be corrected.
xceps = cepsmat(CCfrom:CCto,:);
end

TotalIR = [];
s = sprintf('Parameters are CC=[%d %d]\n',...
        CCfrom,CCto);

for m = 1:length(threshlist)
    %AO to be created
    thresh = threshlist(m); %0.011; %0.015%0.005
    disp('AO to be created ...')

    s = sprintf('Threshold=%4.3f\n',...
        thresh);

    disp(s)
    disp('Audio FO')
    [trn,sfx,lrs,si,sj] = AOS(xceps,thresh); %for testing sparse representation si,sj

    %Create Compror Representation
    [IR,code,compror] = AOIR(trn,sfx,lrs);

    %k = k/max(k);
    %plot(conv(k,[0.25 0.5 1 0.5 0.25]/2.5)*200) %*200 to fit in the 256 fft bins

    TotalIR(m) = sum(IR)/length(trn)

    if 0,
        IR1 = conv(IR,[0.25 0.5 1 0.5 0.25]/2.5);
        figure
        tt = [1:length(IR1)]*bufsize/2/fs;
        plot(tt,IR1)
        axis([0 tt(end) 0 max(IR1)+1])
        %plot([1:length(IR1)]*bufsize/2/fs,IR1)
        %axis([0 length(IR1)*bufsize/2/fs,
        TX = xlabel('time (sec.)');
        set(TX, 'Fontsize', 12);
        TY = ylabel('IR (bits/frame)');
        set(TY, 'Fontsize', 12)
        TTL = sprintf('IR analysis derived from AO, thresh = %5.3f',thresh)
        TH = title(TTL);
        set(TH, 'Fontsize', 16)
        %print('-deps','-r200','AOIR-Fig1.eps')
    end

end

figure
plot(threshlist,TotalIR,'x-')
TH = title('Total IR as function of AO threshold')
set(TH, 'Fontsize', 16)

[IRmax,im] = max(TotalIR);
s = sprintf('Maximum IR achieved for threshold = %4.3f\n', threshlist(im));
disp(s)
