%THIS SCRIPT DEMONSTRATES THE AO ANALYSIS AND GENERATION OF NEW SOUND FILE
%USING AOgent
%THE OUTPUT SOUNDFILE IS AOgen###.wav, WHERE ### ARE THE PARAMETERS USED
%FOR ANALYSIS AND GENERATION

%read soundfile and do ceps
%[x,fs] = wavread('/Users/sdubnov/Documents/Research/work/SPM/SFX/car_crash01.wav');
%[x,fs] = wavread('/Users/sdubnov/Documents/Research/work/SPM/SFX/battle04.wav');
%[x,fs] = wavread('/Users/sdubnov/Documents/Research/work/SPM/SFX/jungle02.wav');
%[x,fs] = wavread('/Users/sdubnov/Documents/Research/work/MVDRGRAM/svega.wav');
%[x,fs] = wavread('/Users/sdubnov/Documents/Research/work/MVDRGRAM/speech.wav');
%[x,fs] = mp3read('/Users/sdubnov/Desktop/Lolita.mp3',[N1 N2],1,4);
%[x,fs] = mp3read('/Users/sdubnov/Music/Classical/BEETHOVEN_PianoSonataNo23_1_Steen-Nokleberg.mp3',[],1,4);
%[x,fs] = mp3read('/Users/sdubnov/Music/Classical/BEETHOVEN_32variationsC-_Adamyan.mp3',[],1,4);
%[x,fs] = mp3read('Albeniz.mp3',[],1,4);
%[x,fs] = mp3read('Philou2.mp3',[],1,4);

disp('Read mp3')
[x,fs] = mp3read('/Users/sdubnov/Music/Classical/BEETHOVEN_SonF-1_Knorre.mp3',[],1,4);

%feature extraction
bufsize = 4096;
hopsize = bufsize/2;
CCfrom = 2;
CCto = 30;
xmat = buffer(x,bufsize,hopsize);
cepsmat = rceps(xmat); %sometimes rceps is -Inf. Should be corrected.
xceps = cepsmat(CCfrom:CCto,:);

%Analysis parameters
thop = hopsize/fs;
thresh = 0.01;

%Generaation parameters
dur = 3*60; 
nout = ceil(dur/thop);
p = 0.87; %0.70;
l = 1;
ktr = cell(1);

s = sprintf('Parameters are CC=[%d %d], Threshold=%4.3f, Prob = %4.2f \n',...
    CCfrom,CCto,thresh,p);
disp(s)

disp('Audio FO')
[trn,sfx] = AO(xceps,thresh);
%[trn,sfx,lrs,si,sj] = AOS(xceps,thresh); %for testing sparse representation si,sj

disp('Generating new audio file from AO')
[sgen,kend,ktrace] = AOgen(trn,sfx,nout,p,1);

%overlap add resynthesis
xnewmat = xmat(:,sgen);
xnew = ola(xnewmat,hopsize);

%avoid clipping before writine the soundfile 
xnewmax = max(abs(xnew));
xnew = xnew / (xnewmax + 0.001);

fout = sprintf('AOgenCC%d_%dTh%4.3fp%4.2f.wav',CCfrom,CCto,thresh,p)
wavwrite(xnew,fs,fout);

%soundsc(x,fs)
%pause
%soundsc(xnew,fs)

% plot(sfx)
% figure
% plot(sgen)
% figure
% imagesc(xceps)
% figure
% imagesc(xceps'*xceps)