function seq = decode(code)

seq = [];
for k = 1:length(code),
    currentcode = code{k};
    if length(currentcode) == 1, %reached a terminal
        seq = [seq currentcode];
    else
        i = length(seq); %current position of seq
        %j = code{k}(2) %for code the describes absolute position (from start)
        j = i-code{k}(2)+1; %if code describes difference from current position
        if j <= 0, j=1; end %error correction for reshuffled / generative codes
        if j>i, continue; end
        L = code{k}(1); %recopy L symbols starting from position j 
        for l = 0:L-1,
            seq = [seq seq(j+l)];
        end
    end
end